;################################################################################
;#										#
;# chipbasic - single chip basic computer with ATMega 16			#
;# full screen editor								#
;# copyright (c) 2006/7 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
autorun_main:	libmio_setnormal		;set color
		libmio_clrscr			;clear screen
		rcall	file_main
		lds	XH,file_sel
		cpi	XH,0x08
		brcc	autorun_01
		sts	libmio_ram+libmio_fastmode,const_1	;disable video
		clt
		rcall	editor_load
		rcall	editor_ptx
		sts	libmio_ram+libmio_fastmode,const_0	;enable video
autorun_01:	rcall	editor_run		;run prog
		rjmp	autorun_main
						